#ifndef CCOMMUNIQUER_H
#define CCOMMUNIQUER_H

#include <QSerialPortInfo>
#include <QSerialPort>
#include <QStringList>
#include <QMessageBox>
#include <QString>
#include "cprotocole.h"
#include "cserialport.h"
#include "global.h"


class CCommuniquer : public QObject
{
    Q_OBJECT

public:
    explicit CCommuniquer(QWidget *parent = 0, QString nomport = "/dev/ttyUSB0");
    ~CCommuniquer();
///////////////////////// AVANT MISSION /////////////////////////

    int debutMission();
    bool envoiDonneesConfig(QByteArray qbaTrame);
    int envoiParamsCapteur(QByteArray qbaTrame);
    int miseAHeureEDD(QByteArray qbaTrame);
    int testComm();

///////////////////////// PENDANT MISSION /////////////////////////

    int debutAcquisition(QByteArray qbaTrame);
    int stopAcquisition(QByteArray qbaTrame);
    int camera(QByteArray qbaTrame);
    int modifParamIncruste(QByteArray qbaTrame);
    int mesuresInstantane(QByteArray qbaTrame);

private slots:
    void onError(QSerialPort::SerialPortError err);
    void onReponse(QString rep);

signals:
    void sigReponse(QString rep);

private:
    CProtocole *mProto;
    CSerialPort *mSp;


};

#endif // CCOMMUNIQUER_H
