#include "cserialport.h"

CSerialPort::CSerialPort(QObject *parent, const QString &nomPort)
{
    mParent = parent;
    mSp = new QSerialPort(parent);
    connect(mSp, SIGNAL(readyRead()), this, SLOT(onReadyRead()));
    connect(mSp, SIGNAL(error(QSerialPort::SerialPortError)), this, SLOT(onError(QSerialPort::SerialPortError)));
    mSp->setPortName(nomPort);

}

CSerialPort::~CSerialPort()
{
    mSp->close();
    delete mSp;
}

int CSerialPort::initialiser(QSerialPort::BaudRate vitesse,
                             QSerialPort::DataBits data,
                             QSerialPort::Parity parity,
                             QSerialPort::StopBits nbStop,
                             QSerialPort::FlowControl flow)
{
    mSp->setBaudRate(vitesse);
    mSp->setDataBits(data);
    mSp->setParity(parity);
    mSp->setStopBits(nbStop);
    mSp->setFlowControl(flow);

    return 0;
}

int CSerialPort::ouvrirPort()
{
    bool res;
    res = mSp->open(QSerialPort::ReadWrite);
    if(!res)
    {
        emit sigErreur(mSp->error());
        mSp->close();
        return -1;
    }
    mSp->setRequestToSend(false);
    return 0;
}

char CSerialPort::ecrire(const char *trame, int nbOctets)
{
    int lg = mSp->write(trame, nbOctets);

    if(lg < nbOctets)
    {
        emit sigErreur(QSerialPort::WriteError);
        return (char)-1;
    }

    return lg;
}

void CSerialPort::onError(QSerialPort::SerialPortError err)
{
    emit sigErreur(err);
}

void CSerialPort::onReadyRead()
{
    QByteArray data;
    data = mSp->readAll();
    qDebug() << "CSerialPort::Reception de : " << data;
    //emit readyRead(data);
    emit sigData(data);
}
