#ifndef CSERIALPORT_H
#define CSERIALPORT_H

#include <QSerialPort>
#include <QDebug>


class CSerialPort : public QObject
{
    Q_OBJECT

private:
    QObject *mParent;
    QSerialPort *mSp;

public:
    CSerialPort(QObject *parent, const QString &nomPort = "/dev/tty.SLAB_USBtoUART");
    ~CSerialPort();
    int initialiser(QSerialPort::BaudRate vitesse, QSerialPort::DataBits data, QSerialPort::Parity parity,
                    QSerialPort::StopBits nbStop, QSerialPort::FlowControl flow);
    int ouvrirPort();
    char ecrire(const char *trame, int nbOctets);

private slots:
    void onError(QSerialPort::SerialPortError err);
    void onReadyRead();

signals:
    void sigErreur(QSerialPort::SerialPortError err);
    void sigData(QByteArray ba);
    void readyRead(QByteArray trame);
};

#endif // CSERIALPORT_H
